/**
*OnlyOffice App
* Implementing OnlyOffice App
*/
var OnlyOfficeApp = OnlyOfficeApp || {};  //Define OnlyOffice App namespace.
/**
*Constructor UNAS App
*/
OnlyOfficeApp.App = function () {
    this.id = 'OnlyOffice';
    this.name = 'OnlyOffice';
    this.version = '6.0.8';
    this.active = false;
    this.menuIcon = '/apps/onlyoffice/images/logo.png?v=6.0.8&';
    this.shortcutIcon = '/apps/onlyoffice/images/logo.png?v=6.0.8&';
    this.entryUrl = '/apps/onlyoffice/onlyoffice.html?v=6.0.8&';
    //this.entryHelpUrl = '/apps/onlyoffice/OnlyOffice_help.html?v=6.0.8&';
    var self = this;
    this.OnlyOfficeAppWindow = function () {
    	if(UNAS.CheckAppState('OnlyOffice')){
    		return false;
    	}
    	self.window=new MUI.Window({
            id: 'OnlyOfficeAppWindow',
            title: UNAS._('OnlyOffice'),
            icon: '/apps/onlyoffice/images/logo_small.png?v=6.0.8&',
            loadMethod: 'xhr',
            width: 750,
            height: 480,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [650, 1200], 'y': [450, 900] },
            contentURL: '/apps/onlyoffice/onlyoffice.html?v=6.0.8&',
            require: {  css: ['/apps/onlyoffice/css/onlyoffice.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("OnlyOffice",'OnlyOfficeAppWindow')}
     	});
    };
    this.OnlyOfficeUninstall = function (){
    	UNAS.RemoveDesktopShortcut('OnlyOffice');
    	UNAS.RemoveMenu('OnlyOffice');
    	//UNAS.RemoveAppFromGroups('OnlyOffice', 'Help');
    	UNAS.RemoveAppFromGroups('OnlyOffice', 'ControlPanel');
    	UNAS.RemoveAppFromApps('OnlyOffice');
    };
    new UNAS.Menu('UNAS_App_SystemTools_Menu', this.name, this.menuIcon, 'OnlyOffice', '', this.OnlyOfficeAppWindow);
    // new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'OnlyOffice', this.OnlyOfficeAppWindow);
    // new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Office', 'Laction' : 11, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Internet', 'Laction' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
    var OnChangeLanguage = function (e) {
    	UNAS.SetMenuTitle('OnlyOffice', UNAS._('OnlyOffice')); //translate menu
        UNAS.SetShortcutTitle('OnlyOffice', UNAS._('OnlyOffice'));
        if (typeof self.window !== 'undefined') {
        	UNAS.SetWindowTitle('OnlyOfficeAppWindow', UNAS._('OnlyOffice'));
        }
    };
    UNAS.LoadTranslation('/apps/onlyoffice/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.OnlyOfficeAppWindow, this.OnlyOfficeUninstall);
};

new OnlyOfficeApp.App();
